global function placeBoomTownObjects

struct {
    bool voper_fight_started = false
    entity wall
} file

void function placeBoomTownObjects()
{
    CreateNessy( <1050, -4888, 2464>, <0, 60, 0>, 10 )
    CreateSimpleButton( <3393, -3798, 2128>, <0, 90, 0>, "to spawn voper", callback_Voper2ButtonTriggered )
    CreateSimpleButton( <5662, -4270, 2860>, <0, 90, 0>, "to fly ;)", callback_AntiGravButtonTriggered, 10.0 )
    CreateSimpleButton( <6153, -1809, 2364>, <0, 90, 0>, "to launch yourself ;)", callback_AntiGravButtonTriggered, 10.0 )
    CreateSimpleButton( <2531, -5115, 2436>, <0, 90, 0>, "to launch yourselft", callback_AntiGravButtonTriggered, 10.0 )
    // CreateSimpleButton( <4633, -3626, 2333>, <0, 0, 0>, "to crush people below", callback_CrusherButtonTriggered, 10.0 )

    file.wall = CreateExpensiveScriptMoverModel( $"models/kodai_live_fire/grave_wall_gasket_512.mdl", <5000, -3752, 1974>, <0,180,0>, SOLID_VPHYSICS, 1000 )
}

void function callback_AntiGravButtonTriggered( entity panel, entity player )
{
    player.kv.gravity = -1.0
    player.SetVelocity( <0,0,400> )
    thread callback_AntiGravButtonTriggeredThreaded( player )
}

void function callback_AntiGravButtonTriggeredThreaded( entity player )
{
    player.EndSignal( "OnDeath" )
    player.EndSignal( "OnDestroy" )

    wait 1

    player.kv.gravity = 0.0
    player.SetVelocity(  player.GetForwardVector() * 1000 )
}

void function callback_CrusherButtonTriggered( entity panel, entity player )
{
    thread callback_CrusherButtonTriggeredThreaded( player )
}

void function callback_CrusherButtonTriggeredThreaded( entity player )
{
    file.wall.NonPhysicsMoveTo( file.wall.GetOrigin() - <1000,0,0>, 0.5, 0.1, 0.1 )

    wait 1

    file.wall.NonPhysicsMoveTo( file.wall.GetOrigin() + <1000,0,0>, 0.5, 0.1, 0.1 )
}

void function callback_Voper2ButtonTriggered( entity panel, entity player )
{
    if ( GetDisabledElements().contains( "voper2" ) )
    {
        SendHudMessage( player, "voper 2 is disabled on this server D:", -1, 0.2, 220, 220, 220, 0, 0.15, 4, 0.15 )
        return
    }

    if ( !HasAllNessies() )
    {
        foreach( entity p in GetPlayerArray() )
            SendHudMessage( p, "You don't have all the nessies [" + CountNessy() + " out of 4 ]", -1, 0.2, 220, 220, 220, 0, 0.15, 4, 0.15 )
        
        return
    }

    if ( file.voper_fight_started )
        return
    
    if ( GetMapName() != "mp_grave" && GAMETYPE != "tdm" && GAMETYPE != "aitdm" )
        return
    
    file.voper_fight_started = !file.voper_fight_started

    StartVoperBattle( 1 )

    ResetNessy()

    thread WaitForCameraEnd()
}

void function WaitForCameraEnd()
{
    entity voper = GetVoper()
    DoomTitan( voper )

    WaitSignal( voper, "CameraHandleOver" )

    thread DropNukes()
    thread DropTitans()
    thread FlyVoper()
}

void function DropNukes()
{
    vector SelectedPlace
    array<entity> titanSpawnPoints

    for(;;)
    {
        SelectedPlace = <0,0,0>
        titanSpawnPoints = SpawnPoints_GetTitan()
        foreach( entity player in GetPlayerArray() )
        {
            entity spawnpoint

            if ( IsValid( player ) )
                spawnpoint = GetClosest( titanSpawnPoints, player.GetOrigin(), 500 )
            
            if ( IsValid( spawnpoint ) )
            {
                SelectedPlace = spawnpoint.GetOrigin()
            }
        }

        if ( SelectedPlace != <0,0,0> )
        {
            entity nukeTitan = CreateNPCTitan( "npc_titan_ogre", TEAM_MILITIA, SelectedPlace, <0,0,0>, [] ) // why do I need []
            SetSpawnOption_NPCTitan( nukeTitan, TITAN_HENCH )
            SetSpawnOption_AISettings( nukeTitan, "npc_titan_ogre_minigun_nuke" )
            SetSpawnOption_Warpfall( nukeTitan )
            DispatchSpawn( nukeTitan )

            NPC_SetNuclearPayload( nukeTitan )
            SetTeam( nukeTitan, 10 )

            thread KillOnLanding( nukeTitan )

            // Chat_ServerBroadcast( "droping the nuke" )
        }

        wait 5
    }
}

void function KillOnLanding( entity titan )
{
    while( IsValid( titan ) && !titan.IsOnGround() )
        WaitFrame()
    
    if ( IsValid( titan ) )
		thread AutoTitan_SelfDestruct( titan )
}

void function DropTitans() 
{

}

void function FlyVoper() 
{
    entity voper = GetVoper()
    ShipStruct ship = GetVoperShip()
    entity link = ship.model.GetParent()

    voper.EndSignal( "OnDeath" )
    voper.EndSignal( "OnDestroy" )
    voper.EndSignal( "FakeDeath" )

    for(;;)
    {
        entity enemy = ViperGetEnemy( voper )

        if ( !IsValid( enemy ) || !IsAlive( enemy ) )
            continue
        
        ShipFlyToPos( ship, CLVec( enemy.GetOrigin() + <0,0,300> + ( enemy.GetForwardVector() * 1000 ) ), enemy.GetAngles() + <0,180,0> )
        link.NonPhysicsRotateTo( enemy.GetAngles() + <0,180,0>, 0.00000001,0,0 )
        // WaitSignal( ship, "Goal" )

        if ( voper.IsOnGround() )
            voper.SetOrigin( voper.GetParent().GetOrigin() )

        if ( RandomIntRange( 0, 1000 ) < 5 )
            waitthread CoreFire()

        WaitFrame()
    }
}